<?php
	session_start();
	require('../../../wp-blog-header.php');
	require('class-wc-comnpay-payment.php');

	$arrayLangValue = array(
		'fr' => array(
			"payer" => "Payer",
			"payer3F" => "Payer en 3 fois",
			"preAutorisation" => "Pré-Autorisation",
			"aucun" => "Aucun modes de paiement configurés",
			"patientez" => "Veuillez patienter..."
		),
		'en' => array(
			"payer" => "Pay",
			"payer3F" => "Pay in 3 times",
			"preAutorisation" => "Pre-authorization",
			"aucun" => "No payment methods configured",
			"patientez" => "Please wait..."

		),
		'it' => array(
			"payer" => "Pagare",
			"payer3F" => "Pagare in 3 volte",
			"preAutorisation" => "Preauthorization",
			"aucun" => "Nessun metodo di pagamento configurato",
			"patientez" => "Per favore aspetta ..."
		),
		'es' => array(
			"payer" => "Pagar",
			"payer3F" => "Pagar en 3 veces",
			"preAutorisation" => "Preautorización",
			"aucun" => "No hay métodos de pago configurados",
			"patientez" => "Espere por favor..."
		),
		'de' => array(
			"payer" => "Zahlen",
			"payer3F" => "In 3 mal bezahlen",
			"preAutorisation" => "Preauthorization",
			"aucun" => "Keine Zahlungsmethoden konfiguriert",
			"patientez" => "Bitte warten ..."
		)
	);

	$arrayLang = array('fr', 'en', 'it', 'es', 'de');
	$langIso = substr(get_bloginfo ( 'language' ), 0, 2);
	if(!in_array($langIso, $arrayLang)){
		$langIso = 'en';
	}
	
	$wooCommerceTotalCart = 0;	// Default value
	if(isset($_GET['idTransaction'])) {
		$order_id = intval($_GET['idTransaction']);
		$order = wc_get_order($order_id);
		$wooCommerceTotalCart = $order->get_total();
	}
	// Process
	if($wooCommerceTotalCart == 0) {
		header("Location: ".get_site_url());
		exit();
	}else{
		$HTML_PROCESS = '';
		$WC_ComNpay = new WC_ComNpay();
		if($WC_ComNpay->get_option('enabled') == "yes") {
			// PREPARE CONFIGURATION
			$COMNPAY_CONFIG = $WC_ComNpay->getComnpayConfig($order_id);
			
			if($WC_ComNpay->totalTypeTrActive() == 0) {
				$HTML_PROCESS .= '<p>' . $arrayLangValue[$langIso]["aucun"] . '</p>';
			}else{
				$iTotalActivePayement = 0;
				$idSubmitAuto = '';


				// Information porteur
				$adressePorteurCarte = $order->get_billing_address_1();
				if(!empty($order->get_billing_address_2())) {
					$adressePorteurCarte .= '(Adresse 2 : '.$order->get_billing_address_2().')';
				}
				$villePorteur = $order->get_billing_country().' '.$order->get_billing_state();
				$porteurDatas = array(
					'adresse'        => $adressePorteurCarte,
					'codePostal'     => $order->get_billing_postcode(),
					'email'          => $order->get_billing_email(),
					'nom'            => $order->get_billing_last_name(),
					'pays'           => $order->get_billing_city(),
					'prenom'         => $order->get_billing_first_name(),
					'qualite'        => 'Particulier',
					'telephone'      => $order->get_billing_phone(),
					'ville'          => $villePorteur,
				);
				if(!empty($order->customer_id)){
					$porteurDatas['refPorteur'] = $order->customer_id;
				}
				$porteurJsonEncode = json_encode($porteurDatas);
				$porteur64_encode = base64_encode($porteurJsonEncode);
				// Fin information porteur


				// DEBIT
				if($WC_ComNpay->get_option('comnpay_gateway_payment_debit') == "yes") {
					$iTotalActivePayement++;
					$PaymentD = new ComNpay_Payment(
						$COMNPAY_CONFIG['tpe_number'],
						$COMNPAY_CONFIG['secret_key'],
						get_site_url().'/wp-content/plugins/woocommerce-comnpay/process_return.php',
						get_site_url().'/wp-content/plugins/woocommerce-comnpay/process_return.php',
						$COMNPAY_CONFIG['url_retour_ipn'],
						"D"
					);
					$HTML_PROCESS .= '<form method="post" action="'.$COMNPAY_CONFIG['plateforme'].'">';
					$HTML_PROCESS .= $PaymentD->buildSecretHTML(
						$COMNPAY_CONFIG['product_name'],
						$wooCommerceTotalCart,
						$order_id."-D-" . time(),
						$porteur64_encode,
						$order_id
					);
					$HTML_PROCESS .= '<input id="btn_D" type="submit" value="'. $arrayLangValue[$langIso]["payer"] .'" />';
					$HTML_PROCESS .= '</form>';
					$HTML_PROCESS .= '<p>&nbsp;</p>';
					$idSubmitAuto .= 'btn_D';
				}
				// PRE-AUTO
				if($WC_ComNpay->get_option('comnpay_gateway_payment_pre_auth') == "yes")	{
					$iTotalActivePayement++;
					$PaymentPreAuth = new ComNpay_Payment(
						$COMNPAY_CONFIG['tpe_number'],
						$COMNPAY_CONFIG['secret_key'],
						get_site_url().'/wp-content/plugins/woocommerce-comnpay/process_return.php',
						get_site_url().'/wp-content/plugins/woocommerce-comnpay/process_return.php',
						$COMNPAY_CONFIG['url_retour_ipn'],
						"PA"
					);
					$HTML_PROCESS .= '<form method="post" action="'.$COMNPAY_CONFIG['plateforme'].'">';
					$HTML_PROCESS .= $PaymentPreAuth->buildSecretHTML(
						$COMNPAY_CONFIG['product_name'],
						$wooCommerceTotalCart,
						$order_id."-PA-" . time(),
						$porteur64_encode,
						$order_id
					);
					$HTML_PROCESS .= '<input id="btn_PA" type="submit" value="'. $arrayLangValue[$langIso]["preAutorisation"] .'" />';
					$HTML_PROCESS .= '</form>';
					$HTML_PROCESS .= '<p>&nbsp;</p>';
					$idSubmitAuto .= 'btn_PA';
				}
				// PNF
				if($WC_ComNpay->get_option('comnpay_gateway_payment_p3f') == "yes")	{
					$minimumP3F = intval($wooCommerceTotalCart);
					if($minimumP3F >= $WC_ComNpay->get_option('comnpay_gateway_minimum_p3f') && $WC_ComNpay->get_option('comnpay_gateway_minimum_p3f') >= 50) {
						$iTotalActivePayement++;

						
						$PaymentP3F = new ComNpay_Payment(
							$COMNPAY_CONFIG['tpe_number'],
							$COMNPAY_CONFIG['secret_key'],
							get_site_url().'/wp-content/plugins/woocommerce-comnpay/process_return.php',
							get_site_url().'/wp-content/plugins/woocommerce-comnpay/process_return.php',
							$COMNPAY_CONFIG['url_retour_ipn'],
							"P3F"
						);
						$HTML_PROCESS .= '<form method="post" action="'.$COMNPAY_CONFIG['plateforme'].'">';
						$HTML_PROCESS .= $PaymentP3F ->buildSecretHTML(
							$COMNPAY_CONFIG['product_name'],
							$wooCommerceTotalCart,
							$order_id."-P3F-" . time(),
							$porteur64_encode,
							$order_id
						);
						$HTML_PROCESS .= '<input id="btn_P3F" type="submit" value="'. $arrayLangValue[$langIso]["payer3F"] .'" />';
						$HTML_PROCESS .= '</form>';
						$HTML_PROCESS .= '<p>&nbsp;</p>';
						$idSubmitAuto .= 'btn_P3F';
					}
				}
				// CLICK AND REDIRECT
				if($iTotalActivePayement == 1)	{
					$HTML_PROCESS .= '<p>' . $arrayLangValue[$langIso]["patientez"] . '</p>';
					$HTML_PROCESS .= '<script type="text/javascript">';
					$HTML_PROCESS .= 'document.getElementById("'.$idSubmitAuto.'").style.display="none";';
					$HTML_PROCESS .= 'document.getElementById("'.$idSubmitAuto.'").click();';
					$HTML_PROCESS .= '</script>';
				}
			}
			// PREPARE PAGE
			get_header();
			?>
			<div class="main">
				<div class="content">
					<?php
						echo $HTML_PROCESS;
					?>
				</div>
				<div class="clearer">
					<span></span>
				</div>
			</div>
			<?php
			get_footer();
			?>
			</div>
			<?php
		}else{
			header("Location: ".get_site_url());
			exit();
		}
	}
?>