<?php
require('../../../wp-blog-header.php');
require('class-wc-comnpay-payment.php');

global $woocommerce;

$explodeDatas = explode('-',$_POST["transactionId"]);
$order_id = $explodeDatas[0];
$TypeTR = $explodeDatas[1];
$arrayLangValue = array(
	'fr' => array(
		'D'	=> 'Paiement classique',
		'P3F'	=> 'Paiement en 3 fois',
		'PA'	=> 'Pré-Autorisation',
		'F218'	=> 'Paiement en 3 fois annulé pour un paiement classique (F218)',
		'expertise'	=> 'Expertise garantie en cours',
		'erreur'	=> 'Une erreur est survenue. Veuillez consulter votre compte AfonePaiement.'
	),
	'en' => array(
		'D'	=> 'Classic payment',
		'P3F'	=> 'Payment in 3 times',
		'PA'	=> 'Pre-authorization',
		'F218'	=> 'Payment in 3 times canceled for a standard payment (F218)',
		'expertise'	=> 'Guaranteed expertise in progress',
		'erreur'	=> 'An error has occurred. Please consult your AfonePaiement account.'

	),
	'it' => array(
		'D'	=> 'Pagamento classico',
		'P3F'	=> 'Pagamento in 3 volte',
		'PA'	=> 'Pre-Autorizzazione',
		'F218'	=> 'Pagamento in 3 volte annullato per un pagamento standard (F218)',
		'expertise'	=> 'Competenze garantite in corso',
		'erreur'	=> 'Si è verificato un errore Si prega di consultare il tuo account AfonePaiement.'
	),
	'es' => array(
		'D'	=> 'Pago clásico',
		'P3F'	=> 'Pago en 3 veces',
		'PA'	=> 'Pre-Autorización',
		'F218'	=> 'Pago en 3 veces cancelado por un pago estándar (F218)',
		'expertise'	=> 'Experiencia garantizada en progreso',
		'erreur'	=> 'Ha ocurrido un error. Por favor consulte su cuenta de AfonePaiement.'
	),
	'de' => array(
		'D'	=> 'Klassische Bezahlung',
		'P3F'	=> 'Zahlung in 3 mal',
		'PA'	=> 'Pre-Authorization',
		'F218'	=> 'Zahlung in 3 mal für eine Standardzahlung (F218) storniert',
		'expertise'	=> 'Garantierte Expertise in Arbeit',
		'erreur'	=> 'Ein Fehler ist aufgetreten. Bitte konsultieren Sie Ihren AfonePaiement-Account'
	)
);
$arrayLang = array('fr', 'en', 'it', 'es', 'de');
$langIso = substr(get_bloginfo ( 'language' ), 0, 2);
if(!in_array($langIso, $arrayLang)){
	$langIso = 'en';
}

$order = new WC_Order( $order_id );
$WC_ComNpay = new WC_ComNpay();
$COMNPAY_CONFIG = $WC_ComNpay->getComnpayConfig($order_id);
$bRemoveCart = true;

if($_POST['result'] == "OK"){
	// Mark
	$order->update_status('processing', __( 'ComNpay ('.$arrayLangValue[$langIso][$TypeTR].')', 'woocommerce' ));
	// Reduce stock levels
	$order->reduce_order_stock();

	$site_url = get_site_url();
	$return_url = ($site_url !== $COMNPAY_CONFIG['url_retour_ok']) ? $COMNPAY_CONFIG['url_retour_ok'] : $order->get_checkout_order_received_url();
	header("Location: ".$return_url);
}
else {
	$codeReponse = intval($_POST['codeReponse']);
	if($codeReponse == 218) {
		// RENVOI DE LA COMMANDE VERS LE PSP EN PAIEMENT CLASSIQUE (D)

		// Information porteur

		$adressePorteurCarte = $order->get_billing_address_1();
		if(!empty($order->get_billing_address_2())) {
			$adressePorteurCarte .= '(Adresse 2 : '.$order->get_billing_address_2().')';
		}
		$villePorteur = $order->get_billing_country().' '.$order->get_billing_state();
		$porteurDatas = array(
			'adresse'		=> $adressePorteurCarte,
			'codePostal'	=> $order->get_billing_postcode(),
			'email'			=> $order->get_billing_email(),
			'nom'			=> $order->get_billing_last_name(),
			'pays'			=> $order->get_billing_city(),
			'prenom'		=> $order->get_billing_first_name(),
			'qualite'		=> 'Particulier',
			'telephone'		=> $order->get_billing_phone(),
			'ville'			=> $villePorteur
		);
		$porteurJsonEncode = json_encode($porteurDatas);
		$porteur64_encode = base64_encode($porteurJsonEncode);

		// Duplicate Order

		$addressDuplicate = array(
			'first_name'	=> $order->get_billing_first_name(),
			'last_name'		=> $order->get_billing_last_name(),
			'company'		=> $order->get_billing_company(),
			'email'			=> $order->get_billing_email(),
			'phone'			=> $order->get_billing_phone(),
			'address_1'		=> $order->get_billing_address_1(),
			'address_2'		=> $order->get_billing_address_2(),
			'city'			=> $order->get_billing_city(),
			'state'			=> $order->get_billing_state(),
			'postcode'		=> $order->get_billing_postcode(),
			'country'		=> $order->get_billing_country()
		);

		$orderDuplicate = wc_create_order();
		$itemsOrder = $order->get_items();
		foreach($itemsOrder as $productId => $productOrdered) {
			$orderDuplicate->add_product( get_product( $productId ), 1 );
		}

		$orderDuplicate->set_address( $addressDuplicate, 'billing' );
		$orderDuplicate->set_address( $addressDuplicate, 'shipping' );

		$orderDuplicate->calculate_totals();

		update_post_meta( $orderDuplicate->id, '_payment_method', 'comnpay' );
		update_post_meta( $orderDuplicate->id, '_payment_method_title', 'ComNpay' );

		// Initialisation

		$PaymentP3F = new ComNpay_Payment(
			$COMNPAY_CONFIG['tpe_number'],
			$COMNPAY_CONFIG['secret_key'],
			get_site_url().'/wp-content/plugins/woocommerce-comnpay/process_return.php',
			get_site_url().'/wp-content/plugins/woocommerce-comnpay/process_return.php',
			$COMNPAY_CONFIG['url_retour_ipn'],
			"D"
		);
		$HTML_PROCESS = '<form method="post" action="'.$COMNPAY_CONFIG['plateforme'].'">';
		$HTML_PROCESS .= $PaymentP3F ->buildSecretHTML(
			$COMNPAY_CONFIG['product_name'],
			$order->get_total(),
			$orderDuplicate->id."-D-F218",
			$porteur64_encode
		);
		$HTML_PROCESS .= '<input id="btn_P3F" type="submit" value="Payer en 3 fois" />';
		$HTML_PROCESS .= '</form>';
		$HTML_PROCESS .= '<script type="text/javascript">';
		$HTML_PROCESS .= 'document.getElementById("btn_P3F").style.display="none";';
		$HTML_PROCESS .= 'document.getElementById("btn_P3F").click();';
		$HTML_PROCESS .= '</script>';

		$order->update_status('cancelled', __( $arrayLangValue[$langIso]['F218'], 'woocommerce' ));	// Annulation

		// Display
		echo $HTML_PROCESS;	// Display
	}
	else if($codeReponse == 219) {
		// COMMANDE EN ATTENTE
		$order->update_status('pending', __( $arrayLangValue[$langIso]['expertise'], 'woocommerce' ));	// Annulation
		header("Location: ".$COMNPAY_CONFIG['url_retour_nok']);


	}
	else {
	    // PAIEMENT ECHOUE
        // Pas de suppression de panier : on redirige l'utilisateur vers la page de paiement afin qu'il puisse réessayer
        $bRemoveCart = false;
        $order->update_status('failed', __( $arrayLangValue[$langIso]['erreur'], 'woocommerce' ));
        header("Location: ".$COMNPAY_CONFIG['url_retour_checkout']);
	}
}

if ($bRemoveCart) {
    // Remove cart
    $woocommerce->cart->empty_cart();
}
?>
